/*
 *   $Id: iftab.h,v 1.3 2025/03/09 19:14:25 snw Exp $
 *    Function prototypes, structs, and macros for FreeM
 *    transactions-in-flight symbol table
 *
 *  
 *   Author: Serena Willis <snw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2020, 2025 Coherent Logic Development LLC
 *
 *
 *   This file is part of FreeM.
 *
 *   FreeM is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   FreeM is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero Public License for more details.
 *
 *   You should have received a copy of the GNU Affero Public License
 *   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
 *
 *   $Log: iftab.h,v $
 *   Revision 1.3  2025/03/09 19:14:25  snw
 *   First phase of REUSE compliance and header reformat
 *
 *
 * SPDX-FileCopyrightText:  (C) 2025 Coherent Logic Development LLC
 * SPDX-License-Identifier: AGPL-3.0-or-later
 **/

typedef struct iftab {
    short action;
    char *key;
    char *data;
    int tlevel;
    int killed;

    struct iftab *next;
} iftab;

extern iftab *iftab_head;

extern iftab *iftab_insert(short action, char *key, char *data, int tlevel);
extern iftab *iftab_retrieve(char *key, char *data);
extern void iftab_delete(char *key);
iftab *iftab_kill(char *key);
extern void iftab_pop_tlevel(int tlevel);
