/*
 *   $Id: ssvn_object.c,v 1.4 2025/03/24 04:13:11 snw Exp $
 *    ^$OBJECT SSVN implementation
 *
 *  
 *   Author: Serena Willis <snw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2023, 2025 Coherent Logic Development LLC
 *
 *
 *   This file is part of FreeM.
 *
 *   FreeM is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   FreeM is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero Public License for more details.
 *
 *   You should have received a copy of the GNU Affero Public License
 *   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
 *
 *   $Log: ssvn_object.c,v $
 *   Revision 1.4  2025/03/24 04:13:11  snw
 *   Replace action macro dat with fra_dat to avoid symbol conflict on OS/2
 *
 *   Revision 1.3  2025/03/09 19:50:47  snw
 *   Second phase of REUSE compliance and header reformat
 *
 *
 * SPDX-FileCopyrightText:  (C) 2025 Coherent Logic Development LLC
 * SPDX-License-Identifier: AGPL-3.0-or-later
 **/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#include "mref.h"
#include "objects.h"
#include "mpsdef.h"

void ssvn_object(short action, char *key, char *data)
{
    char t_key[STRLEN];
    char t_data[STRLEN];

    freem_ref_t *r;

    r = (freem_ref_t *) malloc (sizeof (freem_ref_t));
    NULLPTRCHK(r,"ssvn_object");

    mref_init (r, MREF_RT_SSV, "^$OBJECT");
    internal_to_mref (r, key);

    switch (action) {

        case fra_order:
        case fra_query:
        case fra_dat:
        case bigquery:
        case get_sym:
            symtab (action, key, data);
            goto done;

        

        default:
            merr_raise (M29);
            goto done;
    }

done:
    free (r);
}
